unit pMainForm;

{$WARN UNIT_PLATFORM OFF}
{$WARN SYMBOL_PLATFORM OFF}
{$WARN SYMBOL_DEPRECATED OFF}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SiUSBXp_h, StdCtrls, Contnrs, ExtCtrls, ComCtrls, Menus, FileCtrl,
  INIFiles, DateUtils, pDaysForm, Taskbar;

const
  STATE_NONE    = 0;
  STATE_RUNNING = 1;


type
  TOneSegTuner = class(TObject)
    Handle         : SI_HANDLE;
    Number         : Integer;
    TunerID        : String;
    Channel        : Integer;
    LastTime       : TDateTime;
    CheckFlag      : Boolean;
    TunerState     : Integer;
    StatusText     : String;
    FileName       : String;
    FilePath       : String;
    BeforeFileName : String;
    OutFile        : TFileStream;
    IdxFile        : TFileStream;
    RecvPacket     : LongInt;
    BeforeBuf      : array[0..197] of Char;
    BeforeBufSize  : Integer;
    LastTimeDiv    : TDateTime;
    RetryNum       : Integer;
  end;

  TOneSegForm = class(TForm)
    TunerTab: TTabControl;
    TabPanel: TPanel;
    Label1: TLabel;
    TunerIDEdit: TEdit;
    Label2: TLabel;
    ChannelCombo: TComboBox;
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    X1: TMenuItem;
    R1: TMenuItem;
    R2: TMenuItem;
    A1: TMenuItem;
    TSFolderLabel: TLabel;
    Label3: TLabel;
    StatusEdit: TEdit;
    ProbeTimer: TTimer;
    RecordTimer: TTimer;
    PacketCountEdit: TEdit;
    D1: TMenuItem;
    TrayIcon1: TTrayIcon;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    X2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TunerTabChange(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure R2Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure ChannelComboChange(Sender: TObject);
    procedure ProbeTimerTimer(Sender: TObject);
    procedure RecordTimerTimer(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private 錾 }
    ININame       : String;
    FTSFolder     : String;
    FRecDays      : Integer;
    FProductString: String;
    SelectedTuner : TOneSegTuner;
    Tuners        : TObjectList;
    LastDeleteNow : TDateTime;
    function  SetRegister0     (Tuner:TOneSegTuner; reg:BYTE; dat:BYTE): Integer;
    function  SetRegister1     (Tuner:TOneSegTuner; reg:BYTE; dat:BYTE): Integer;
    function  PlainSend        (Tuner:TOneSegTuner; reg1:BYTE; reg2:BYTE; reg3:BYTE; reg4:BYTE; reg5:BYTE): Integer;
    function  RequestStatus    (Tuner:TOneSegTuner; reg1:BYTE; reg2:BYTE; reg3:BYTE; var dat:BYTE): Integer;
    function  Bootup           (Tuner:TOneSegTuner): Integer;
    function  SetChannel       (Tuner:TOneSegTuner; ch:Integer): Integer;
    function  SerialToTuner    (Serial:String):TOneSegTuner;
    procedure RefreshTunerList;
    procedure RefreshChannelList;
    procedure InitializeTuner  (Tuner: TOneSegTuner);
    procedure DeleteTuner      (Tuner: TOneSegTuner);
    procedure SetTSFolder      (str:String);
    procedure SetRecDays       (i:Integer);
    function  AnalyzeTOT       (buf:PChar; tot:PChar): TDateTime;
    procedure DeleteOldFiles   (nw:TDateTime);
    procedure TunerTabUpdate   (Sender: TObject);
  public
    { Public 錾 }
    property RecDays      : Integer read FRecDays       write SetRecDays;
    property TSFolder     : String  read FTSFolder      write SetTSFolder;
    property ProductString: String  read FProductString write FProductString;
  end;

var
  OneSegForm: TOneSegForm;

implementation

{$R *.dfm}

// ==========================================================
//   
// ==========================================================

procedure TOneSegForm.FormCreate(Sender: TObject);
var
  INI: TINIFile;
begin
  ININame := ChangeFileExt(Application.ExeName,'.ini');
  inherited;

  INI := TINIFile.Create(ININame);
  try
    TSFolder      := INI.ReadString ('Config','TSFolder','');
    RecDays       := INI.ReadInteger('Config','RecDays',3);
    ProductString := INI.ReadString ('Config','ProductString','UOT-100');
  finally
    INI.Free;
  end;

  //vZX̗D揇ʂύX
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  //Xbh̗D揇ʂύX
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  SelectedTuner := nil;
  Tuners        := TObjectList.Create;
  LastDeleteNow := 0;
  RefreshChannelList;
  RefreshTunerList;
end;


// ==========================================================
//   I
// ==========================================================

procedure TOneSegForm.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  // Tuner ListSJ
  if Assigned(Tuners) then
  begin
    for i:=0 to Tuners.Count-1 do
    begin
      DeleteTuner(TOneSegTuner(Tuners[i]));
      Sleep(2000);
    end;
    Tuners.Free;
  end;
end;


// ==========================================================
//   Ât@C̍폜
// ==========================================================

procedure TOneSegForm.DeleteOldFiles(nw:TDateTime);
var
  sr1,sr2: TSearchRec;
  y,m,d,h: Integer;
  fexsts : Boolean;
begin
  // fBNg̃XL
  if FindFirst(IncludeTrailingPathDelimiter(TSFolder)+'*.*', faDirectory , sr1) = 0 then
  begin
    repeat
      if (sr1.Attr and faDirectory) <> 0 then
      begin
        y := StrToIntDef(Copy(sr1.Name,1,2),-1);
        m := StrToIntDef(Copy(sr1.Name,3,2),-1);
        d := StrToIntDef(Copy(sr1.Name,5,2),-1);
        if ((Length(sr1.Name)=6) and (y<>-1) and (m<>-1) and (d<>-1)) then
        begin
          // fBNgt炵
          if ((DateOf(nw)-EncodeDate(y+2000,m,d))>=RecDays) then
          begin
            // ÂfBNĝ悤t@C̃XL
            fexsts := False;
            if FindFirst(IncludeTrailingPathDelimiter(IncludeTrailingPathDelimiter(TSFolder)+sr1.Name)+'*.*', faAnyFile, sr2) = 0 then
            begin
              repeat
                if (sr2.Attr and faDirectory) = 0 then
                begin
                  y := StrToIntDef(Copy(sr2.Name,1,2),-1);
                  m := StrToIntDef(Copy(sr2.Name,3,2),-1);
                  d := StrToIntDef(Copy(sr2.Name,5,2),-1);
                  h := StrToIntDef(Copy(sr2.Name,7,2),-1);
                  if ((y<>-1) and (m<>-1) and (d<>-1) and (h<>-1)) then
                  begin
                    if ((nw-EncodeDateTime(y+2000,m,d,h,0,0,0))>RecDays) then
                    begin
                      DeleteFile(IncludeTrailingPathDelimiter(IncludeTrailingPathDelimiter(TSFolder)+sr1.Name)+sr2.Name);
                    end
                      else
                    begin
                      fexsts := True;
                    end;
                  end
                    else
                  begin
                    fexsts := True;
                  end;
                end
                  else
                begin
                  if (sr2.Name<>'.') and (sr2.Name<>'..') then
                  begin
                    fexsts := True;
                  end;
                end;
              until FindNext(sr2) <> 0;
              FindClose(sr2);
            end;
            if (not fexsts) then
            begin
              RemoveDir(IncludeTrailingPathDelimiter(TSFolder)+sr1.Name);
            end;
          end;
        end;
      end;
    until FindNext(sr1) <> 0;
    FindClose(sr1);
  end;
end;


// ==========================================================
//   vpeB
// ==========================================================

procedure TOneSegForm.SetTSFolder(str:String);
var
  INI  : TINIFile;
  str2 : String;
begin
  str2      := ExcludeTrailingPathDelimiter(str);

  FTSFolder := '';
  if (DirectoryExists(str2)) then FTSFolder := str2;

  // INIt@C֏
  INI := TINIFile.Create(ININame);
  try
    INI.WriteString('Config','TSFolder',TSFolder);
  finally
    INI.Free;
  end;

  // \
  if (FTSFolder = '') then
  begin
    TSFolderLabel.Caption := 'ۑFݒ';
  end
    else
  begin
    TSFolderLabel.Caption := 'ۑF'+FTSFolder;
  end;
end;

procedure TOneSegForm.SetRecDays(i:Integer);
var
  INI  : TINIFile;
begin
  if (i>0) then
  begin
    FRecDays := i;
    INI := TINIFile.Create(ININame);
    try
      INI.WriteInteger('Config','RecDays',FRecDays);
    finally
      INI.Free;
    end;
  end;
end;


// ==========================================================
//   `[iID`[iIuWFNg
// ==========================================================

function  TOneSegForm.SerialToTuner(Serial:String):TOneSegTuner;
var
  Tuner : TOneSegTuner;
  i     : Integer;
begin
  Result := nil;
  if Assigned(Tuners) then
  begin
    for i:=0 to Tuners.Count-1 do
    begin
      Tuner := TOneSegTuner(Tuners[i]);
      if Assigned(Tuner) then
      begin
        if (Tuner.TunerID = Serial) then Result := Tuner;
      end;
    end;
  end;
end;


// ==========================================================
//   w`[i
// ==========================================================

procedure TOneSegForm.InitializeTuner(Tuner: TOneSegTuner);
var
  ret: Integer;
begin
  if Assigned(Tuner) then
  begin
    try
      ret := SI_Open(Tuner.Number,Tuner.Handle);
      if (ret <> SI_SUCCESS) then raise Exception.Create('SI_Open');
      ret := SI_FlushBuffers(Tuner.Handle,1,1);
      if (ret <> SI_SUCCESS) then raise Exception.Create('SI_FlushBuffers');
      ret := SI_SetTimeouts(500,500);
      if (ret <> SI_SUCCESS) then raise Exception.Create('SI_SetTimeouts');
      PlainSend(Tuner,$03,$00,$00,$00,$00);
      ret := Bootup(Tuner);
      if (ret <> SI_SUCCESS) then raise Exception.Create('Bootup');
      if (Tuner.Channel<>-1) then
      begin
        ret := SetChannel(Tuner,Tuner.Channel);
        if (ret <> SI_SUCCESS) then raise Exception.Create('SetChannel');
      end;
      Tuner.BeforeBufSize := 0;
      Tuner.StatusText  := '';
      Tuner.LastTime    := Now;
      Tuner.LastTimeDiv := 0;
      Tuner.RetryNum    := 0;
      Tuner.TunerState  := STATE_RUNNING;
    except
      if (Tuner.Handle <> nil) then
      begin
        PlainSend(Tuner,$03,$00,$00,$00,$00);
        Sleep(500);
        SI_Close(Tuner.Handle);
      end;
      Tuner.Handle     := nil;
      Tuner.StatusText := 's';
      Tuner.TunerState := STATE_NONE;
    end;
  end;
end;


// ==========================================================
//   w`[i폜
// ==========================================================

procedure TOneSegForm.DeleteTuner(Tuner: TOneSegTuner);
begin
  if Assigned(Tuner) then
  begin
    if (Tuner.Handle<>nil) then
    begin
      PlainSend(Tuner,$03,$00,$00,$00,$00);
      Sleep(500);
      SI_Close(Tuner.Handle);
      Tuner.Handle := nil;
    end;
    if Assigned(Tuner.OutFile) then FreeAndNil(Tuner.OutFile);
    if Assigned(Tuner.IdxFile) then FreeAndNil(Tuner.IdxFile);
  end;
end;


// ==========================================================
//   USBڑ𒲂׃`[iXgXV
// ==========================================================

procedure TOneSegForm.RefreshTunerList;
var
  num  : DWORD;
  ret  : Integer;
  i,n  : Integer;
  pc   : array [0..SI_MAX_DEVICE_STRLEN-1] of Char;
  Tuner: TOneSegTuner;
  INI  : TINIFile;
  flg  : Boolean;
begin
  INI := TINIFile.Create(ININame);
  flg := False;
  try
    if Assigned(Tuners) then
    begin
      for i:=0 to Tuners.Count-1 do
      begin
        TOneSegTuner(Tuners[i]).CheckFlag := False;
      end;

      ret := SI_GetNumDevices(num);
      if (ret = SI_SUCCESS) then
      begin
        for i:=0 to (num-1) do
        begin
          ret := SI_GetProductString(i,pc,SI_RETURN_DESCRIPTION);
          if (ret = SI_SUCCESS) then
          begin
            if (Pos(ProductString,String(pc))<>0) then
            begin
              ret := SI_GetProductString(i,pc,SI_RETURN_SERIAL_NUMBER);
              if (ret = SI_SUCCESS) then
              begin
                Tuner := SerialToTuner(String(pc));
                if (Tuner = nil) then
                begin
                  // New one
                  n := Tuners.Add(TOneSegTuner.Create);
                  Tuner := TOneSegTuner(Tuners[n]);
                  Tuner.TunerID       := String(pc);
                  Tuner.Handle        := nil;
                  Tuner.Number        := i;
                  Tuner.Channel       := INI.ReadInteger('Tuner'+Tuner.TunerID,'Channel',-1);
                  Tuner.LastTime      := 0;
                  Tuner.LastTimeDiv   := 0;
                  Tuner.RetryNum      := 0;
                  Tuner.BeforeBufSize := 0;
                  Tuner.CheckFlag     := True;
                  Tuner.StatusText    := '';
                  Tuner.TunerState    := STATE_NONE;
                  TunerTab.Tabs.Add(Tuner.TunerID);
                  flg := True;
                end
                  else
                begin
                  // Old one
                  Tuner.Number    := i;
                  Tuner.CheckFlag := True;
                end;
              end;
            end;
          end;
        end;

        // Ȃ̂폜
        for i:=Tuners.Count-1 downto 0 do
        begin
          Tuner := TOneSegTuner(Tuners[i]);
          if not Tuner.CheckFlag then
          begin
            for n:=0 to TunerTab.Tabs.Count-1 do
            begin
              if (TunerTab.Tabs[n] = Tuner.TunerID) then
              begin
                TunerTab.Tabs.Delete(n);
                break;
              end;
            end;
            DeleteTuner(Tuner);
            Tuners.Delete(i);
            flg := True;
          end;
        end;
      end;
    end;
  finally
    INI.Free;
  end;

  // ^uXV
  if (flg) then
  begin
    TunerTabChange(TunerTab);
  end
    else
  begin
    TunerTabUpdate(TunerTab);
  end;
end;

// ==========================================================
//   `lꗗXVij
// ==========================================================

procedure TOneSegForm.RefreshChannelList;
var
  i: Integer;
  str: String;
begin
  ChannelCombo.Items.Clear;
  ChannelCombo.Items.Add('ݒ');
  for i:=13 to 62 do
  begin
    str := IntToStr(i);
    case i of
    20: str := str + ' (TOKYO MX)';
    21: str := str + ' (tWer)';
    22: str := str + ' (TBS)';
    23: str := str + ' (er)';
    24: str := str + ' (er)';
    25: str := str + ' ({er)';
    26: str := str + ' (NHK)';
    27: str := str + ' (NHK)';
    end;
    ChannelCombo.Items.Add(str);
  end;
  
  // ^uXV
  TunerTabChange(TunerTab);
end;


// ==========================================================
//   `[i^u\XV
// ==========================================================

procedure TOneSegForm.TunerTabChange(Sender: TObject);
begin
  if (TunerTab.TabIndex<0) then
  begin
    SelectedTuner := nil;
  end
    else
  begin
    SelectedTuner := SerialToTuner(TunerTab.Tabs[TunerTab.TabIndex]);
  end;
  if (SelectedTuner <> nil) then
  begin
    if (SelectedTuner.Channel<0) then
    begin
      if (ChannelCombo.ItemIndex<>0) then ChannelCombo.ItemIndex := 0;
    end
      else
    begin
      if (((SelectedTuner.Channel-13)>=0) and ((SelectedTuner.Channel-13)<(ChannelCombo.Items.Count-1))) then
      begin
        if (ChannelCombo.ItemIndex <> (SelectedTuner.Channel-13+1)) then ChannelCombo.ItemIndex := SelectedTuner.Channel-13+1;
      end;
    end;
  end;
  TunerTabUpdate(Sender);
end;

procedure TOneSegForm.TunerTabUpdate(Sender: TObject);
begin
  if (TunerTab.TabIndex<0) then
  begin
    SelectedTuner := nil;
  end
    else
  begin
    SelectedTuner := SerialToTuner(TunerTab.Tabs[TunerTab.TabIndex]);
  end;
  if (SelectedTuner <> nil) then
  begin
    if (TunerIDEdit.Text <> SelectedTuner.TunerID) then TunerIDEdit.Text := SelectedTuner.TunerID;
    if (StatusEdit.Text  <> SelectedTuner.StatusText) then StatusEdit.Text  := SelectedTuner.StatusText;
    if (PacketCountEdit.Text <> IntToStr(SelectedTuner.RecvPacket)) then PacketCountEdit.Text := IntToStr(SelectedTuner.RecvPacket);
    if (TabPanel.Visible<>True) then TabPanel.Visible := True;
  end
    else
  begin
    if (TabPanel.Visible<>False) then TabPanel.Visible := False;
  end;
end;


// ==========================================================
//   j[
// ==========================================================

// I
procedure TOneSegForm.X1Click(Sender: TObject);
begin
  Application.Terminate;
end;

// tH_I
procedure TOneSegForm.R2Click(Sender: TObject);
var
  strDir: String;
begin
  if SelectDirectory(strDir,[],0)  then
  begin
    TSFolder := strDir;
  end;
end;

// nI
procedure TOneSegForm.A1Click(Sender: TObject);
begin
  RefreshChannelList;
end;



// `lύX
procedure TOneSegForm.ChannelComboChange(Sender: TObject);
var
  INI: TINIFile;
begin
  INI := TINIFile.Create(ININame);
  try
    if Assigned(SelectedTuner) then
    begin
      if (SelectedTuner.Channel <> (ChannelCombo.ItemIndex-1+13)) then
      begin
        PlainSend(SelectedTuner,$03,$00,$00,$00,$00);
        Sleep(500);
        SelectedTuner.Channel := ChannelCombo.ItemIndex-1+13;
        INI.WriteInteger('Tuner'+SelectedTuner.TunerID,'Channel',SelectedTuner.Channel);
        // `lݒ
        SetChannel(SelectedTuner,SelectedTuner.Channel);
      end;
    end;
  finally
    INI.Free;
  end;
end;


// ==========================================================
//   `[i[ԃ`FbNi0.5bƁj
// ==========================================================

procedure TOneSegForm.ProbeTimerTimer(Sender: TObject);
var
  i     : Integer;
  Tuner : TOneSegTuner;
  lt    : TDateTime;
begin
  try
    RefreshTunerList;

    if Assigned(Tuners) then
    begin
      for i:=0 to Tuners.Count-1 do
      begin
        Tuner := TOneSegTuner(Tuners[i]);
        if Assigned(Tuner) then
        begin
          case Tuner.TunerState of
          STATE_NONE:
            begin
              InitializeTuner(Tuner);
              break;
            end;
          STATE_RUNNING:
            begin
              // 
            end;
          end;

          // `[i[~܂ĂH
          lt := Tuner.LastTime+Tuner.LastTimeDiv;
          if SecondsBetween(lt,Now)>15 then
          begin
            Tuner.RetryNum := Tuner.RetryNum+1;
            if (Tuner.RetryNum<5) then
            begin
              // R}hđM
              Tuner.StatusText := 'R}hđM';
              PlainSend(Tuner,$03,$00,$00,$00,$00);
              Sleep(100);
              SetChannel(Tuner,Tuner.Channel);
              break;
            end
              else
            begin
              // Vbg_E
              DeleteTuner(Tuner);
              Tuner.StatusText := 'ď';
              Tuner.TunerState := STATE_NONE;
              break;
            end;
          end;
        end;
      end;
    end;
  except
    //
  end;
end;




// ==========================================================
//   `[i[ݒ
// ==========================================================

function TOneSegForm.PlainSend(Tuner:TOneSegTuner; reg1:BYTE; reg2:BYTE; reg3:BYTE; reg4:BYTE; reg5:BYTE): Integer;
var
  ret : Integer;
  num : DWORD;
  buf : array [0..4] of Char;
begin
  ret := SI_WRITE_ERROR;
  if (Integer(Tuner.Handle) >= 0) then
  begin
    buf[0] := Chr(reg1);
    buf[1] := Chr(reg2);
    buf[2] := Chr(reg3);
    buf[3] := Chr(reg4);
    buf[4] := Chr(reg5);
    ret := SI_Write(Tuner.Handle,buf,5,num,nil);
    if (num <> 5) then ret := SI_WRITE_ERROR;
  end;
  Result := ret;
end;


function TOneSegForm.SetRegister0(Tuner:TOneSegTuner; reg:BYTE; dat:BYTE): Integer;
var
  ret : Integer;
  num : DWORD;
  buf : array [0..4] of Char;
begin
  ret := SI_WRITE_ERROR;
  if (Integer(Tuner.Handle) >= 0) then
  begin
    buf[0] := #$00;
    buf[1] := #$00;
    buf[2] := Chr(reg);
    buf[3] := Chr(dat);
    buf[4] := #$00;
    ret := SI_Write(Tuner.Handle,buf,5,num,nil);
    if (num <> 5) then ret := SI_WRITE_ERROR;
  end;
  Result := ret;
end;

function TOneSegForm.SetRegister1(Tuner:TOneSegTuner; reg:BYTE; dat:BYTE): Integer;
var
  ret : Integer;
  num : DWORD;
  buf : array [0..4] of Char;
begin
  ret := SI_WRITE_ERROR;
  if (Integer(Tuner.Handle) >= 0) then
  begin
    buf[0] := #$00;
    buf[1] := #$01;
    buf[2] := Chr(reg);
    buf[3] := Chr(dat);
    buf[4] := #$00;
    ret := SI_Write(Tuner.Handle,buf,5,num,nil);
    if (num <> 5) then ret := SI_WRITE_ERROR;
  end;
  Result := ret;
end;

function TOneSegForm.RequestStatus(Tuner:TOneSegTuner; reg1:BYTE; reg2:BYTE; reg3:BYTE; var dat:BYTE): Integer;
var
  ret : Integer;
  num : DWORD;
  buf : array [0..19] of Char;
begin
  ret := SI_WRITE_ERROR;
  if (Integer(Tuner.Handle) >= 0) then
  begin
    // Write
    buf[0] := Chr(reg1);
    buf[1] := Chr(reg2);
    buf[2] := Chr(reg1);
    buf[3] := #$FF;
    buf[4] := #$FF;
    ret := SI_Write(Tuner.Handle,buf,5,num,nil);
    if (num <> 5) then ret := SI_WRITE_ERROR;

    if (ret = SI_SUCCESS) then
    begin
      // Read
      ret := SI_Read(Tuner.Handle,buf,20,num,nil);
      if (num <> 20) then ret := SI_READ_ERROR;

      if ((buf[0]<>#$48) or (buf[1]<>#$75) or (buf[2]<>#$09) or (buf[3]<>#$15) or (buf[4]<>#$58) or (buf[5]<>#$01) or (buf[6]<>#$01)) then ret := SI_READ_ERROR;
      dat := Ord(buf[7]);
    end;
  end;
  Result := ret;
end;


function TOneSegForm.Bootup(Tuner:TOneSegTuner): Integer;
const
  datas:Array [$73 .. $b6] of BYTE = (
      $00,$70,$89,$c3,$12,$83,$00,$20,$00,$27,$14,$04,$b0,$00,$93,$30,
      $09,$1d,$8c,$9c,$a4,$09,$ff,$b2,$94,$ce,$55,$3a,$7f,$81,$7f,$81,
      $01,$c6,$72,$46,$7e,$13,$00,$00,$00,$00,$00,$e0,$7f,$04,$b0,$7e,
      $7f,$02,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,$1f,
      $1f,$1f,$21,$02 );
var
  dat : BYTE;
  i   : Integer;
begin
  // First bootup
  for i:=$73 to $b6 do
  begin
    Result := SetRegister1(Tuner,i,datas[i]);      if (Result <> SI_SUCCESS) then exit;
  end;

  Result := SetRegister1 (Tuner,$A2,$00);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister1 (Tuner,$A3,$48);          if (Result <> SI_SUCCESS) then exit;
  Result := RequestStatus(Tuner,$01,$01,$7F, dat); if (Result <> SI_SUCCESS) then exit;

  Result := SetRegister1 (Tuner,$7F,$70);          if (Result <> SI_SUCCESS) then exit;
  Result := RequestStatus(Tuner,$01,$01,$68, dat); if (Result <> SI_SUCCESS) then exit;

  Result := SetRegister1 (Tuner,$7F,$B0);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister1 (Tuner,$74,$70);          if (Result <> SI_SUCCESS) then exit;
  //
  Result := SetRegister0 (Tuner,$01,$01);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$05,$01);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$06,$70);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$4D,$0E);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$70,$01);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$40,$0F);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$43,$F8);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$47,$C0);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$A1,$40);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$A5,$4C);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$B9,$D9);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$AC,$01);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$AD,$80);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$AE,$43);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$AF,$01);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$B0,$22);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$BD,$E9);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$C0,$1C);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$C4,$20);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$C5,$04);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$CA,$33);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$08,$0C);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$09,$12);          if (Result <> SI_SUCCESS) then exit;
  Result := SetRegister0 (Tuner,$01,$02);          if (Result <> SI_SUCCESS) then exit;
end;

function TOneSegForm.SetChannel(Tuner:TOneSegTuner; ch:Integer): Integer;
const
//     0   1   2   3   4   5   6   7   8   9
  p1  : Array [13 .. 62] of BYTE = (
                  $88,$89,$89,$8A,$8A,$8A,$8B,
      $8B,$8C,$8C,$8D,$8D,$8D,$8D,$8E,$8F,$8F,
      $86,$86,$87,$87,$88,$88,$89,$89,$8A,$8A,
      $8A,$8B,$8B,$8C,$8C,$8C,$8D,$8D,$8D,$8E,
      $8E,$8F,$8F,$86,$86,$86,$87,$87,$87,$88,
      $88,$89,$8A );
  p2  : Array [13 .. 62] of BYTE = (
                  $30,$30,$30,$30,$30,$30,$30,
      $30,$30,$30,$30,$30,$30,$30,$30,$30,$30,
      $70,$70,$70,$70,$70,$70,$70,$70,$70,$70,
      $70,$70,$70,$70,$70,$70,$70,$70,$70,$70,
      $70,$70,$70,$B0,$B0,$B0,$B0,$B0,$B0,$B0,
      $B0,$B0,$B0 );
var
  dat      : BYTE;
  p3,p4,p5 : BYTE;
  mhz      : Integer;
begin
  if ((ch>=13) and (ch<=62)) then
  begin
    mhz := 473 + (ch-13)*6;
    p3  := (mhz shr 4);
    p4  := (mhz and $0F);
    if (ch<=20) then p5 := $8c else p5 := $94;
    Result := SetRegister1 (Tuner,$78,$83);          if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$75,p1[ch]);       if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$82,p2[ch]);       if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$84,p3);           if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$85,p5);           if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$86,$9C);          if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$87,$A4);          if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$88,p4);           if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$83,$0B);          if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$83,$09);          if (Result <> SI_SUCCESS) then exit;
    Result := RequestStatus(Tuner,$01,$01,$70, dat); if (Result <> SI_SUCCESS) then exit;
    //
    Result := SetRegister1 (Tuner,$75,p1[ch]+1);     if (Result <> SI_SUCCESS) then exit;
    Result := SetRegister1 (Tuner,$82,p2[ch]);       if (Result <> SI_SUCCESS) then exit;
    Result := RequestStatus(Tuner,$01,$01,$70, dat); if (Result <> SI_SUCCESS) then exit;
    //
    Result := RequestStatus(Tuner,$01,$01,$69, dat); if (Result <> SI_SUCCESS) then exit;
    //
    Result := SetRegister0 (Tuner,$01,$02);          if (Result <> SI_SUCCESS) then exit;
    Result := RequestStatus(Tuner,$01,$00,$32, dat); if (Result <> SI_SUCCESS) then exit;
    //
    Result := PlainSend(Tuner,$02,$00,$00,$00,$00);
  end
    else
  begin
    Result := SI_INVALID_PARAMETER;
  end;
end;


// ==========================================================
//   ^`FbNi100msƁj
// ==========================================================

procedure TOneSegForm.RecordTimerTimer(Sender: TObject);
var
  i         : Integer;
  Tuner     : TOneSegTuner;
  RxLen,Stat: DWORD;
  ret       : Integer;
  buf       : array [0..SI_MAX_READ_SIZE] of Char;
  totcode   : array [0..4] of Char;
  num       : DWORD;
  pos       : Integer;
  tot       : TDateTime;
  str,datstr: String;
  fn        : String;
  ptr       : DWORD;
begin
  try
    if Assigned(Tuners) then
    begin
      for i:=0 to Tuners.Count-1 do
      begin
        Tuner := TOneSegTuner(Tuners[i]);

        if (Tuner <> nil) then
        begin
          if (Tuner.TunerState = STATE_RUNNING) then
          begin
            ret := SI_CheckRXQueue(Tuner.Handle, RxLen, Stat);
            if (ret = SI_SUCCESS) then
            begin
              while (RxLen >= 197) do
              begin
                // MI
                if (RxLen>SI_MAX_READ_SIZE) then RxLen := SI_MAX_READ_SIZE;
                Move(Tuner.BeforeBuf,buf,Tuner.BeforeBufSize);
                ret := SI_Read(Tuner.Handle,buf[Tuner.BeforeBufSize],RxLen,num,nil);
                num := num + DWORD(Tuner.BeforeBufSize);
                Tuner.BeforeBufSize := 0;
                pos := 0;

                if (ret = SI_SUCCESS) then
                begin
                  while ((buf[pos+0] <> #$47) and (num >= 197)) do
                  begin
                    pos := pos + 1;
                    num := num - 1;
                  end;

                  while(num >= 197) do
                  begin
                    if (buf[pos+0] = #$47) then
                    begin
                      // TOTpPbg?
                      if (((ord(buf[pos+1]) and $1F) = $00) and (buf[pos+2] = #$14)) then
                      begin
                        // TOTpPbg
                        tot := AnalyzeTOT(@buf[pos],totcode);
                        if (tot <> 0) then
                        begin
                          Tuner.LastTime := tot;
                          Tuner.LastTimeDiv := Now-tot;
                          DateTimeToString(str,'yy/mm/dd hh:nn:ss',Tuner.LastTime);
                          Tuner.StatusText := 'MF'+str;
                          //
                          DateTimeToString(str   ,'yymmddhh',Tuner.LastTime);
                          DateTimeToString(datstr,'yymmdd'  ,Tuner.LastTime);
                          Tuner.FileName := str+'_Ch'+IntToStr(Tuner.Channel);
                          Tuner.FilePath := datstr;
                          //
                          if (Tuner.FileName <> Tuner.BeforeFileName) then
                          begin
                            // Close before files
                            if Assigned(Tuner.OutFile) then FreeAndNil(Tuner.OutFile);
                            if Assigned(Tuner.IdxFile) then FreeAndNil(Tuner.IdxFile);

                            // Directory
                            if (not DirectoryExists(TSFolder+'\'+Tuner.FilePath)) then
                            begin
                              MkDir(TSFolder+'\'+Tuner.FilePath);
                            end;

                            // Open New file
                            fn := TSFolder+'\'+Tuner.FilePath+'\'+Tuner.FileName;
                            if (FileExists(fn+'.ts')) then
                            begin
                              Tuner.OutFile := TFileStream.Create(fn+'.ts', fmOpenReadWrite or fmShareDenyNone);
                            end
                              else
                            begin
                              Tuner.OutFile := TFileStream.Create(fn+'.ts', fmCreate or fmShareDenyNone);
                            end;
                            Tuner.OutFile.Seek(0,soFromEnd);

                            // Open New index file
                            if (FileExists(fn+'.idx')) then
                            begin
                              Tuner.IdxFile := TFileStream.Create(fn+'.idx', fmOpenReadWrite or fmShareDenyNone);
                            end
                              else
                            begin
                              Tuner.IdxFile := TFileStream.Create(fn+'.idx', fmCreate or fmShareDenyNone);
                            end;
                            Tuner.IdxFile.Seek(0,soFromEnd);

                            // New file stand-by
                            Tuner.BeforeFileName := Tuner.FileName;
                          end;

                          // index
                          if Assigned(Tuner.IdxFile) then
                          begin
                            ptr := Tuner.OutFile.Position;
                            Tuner.IdxFile.Write(totcode,5);
                            Tuner.IdxFile.Write(ptr,sizeof(ptr));
                          end;

                          // svt@C̍폜
                          if ((HourOf(tot) <> HourOf(LastDeleteNow)) and (tot>LastDeleteNow)) then
                          begin
                            DeleteOldFiles(tot);
                            LastDeleteNow := tot;
                          end;
                        end;
                      end;
                      if Assigned(Tuner.OutFile) then Tuner.OutFile.Write(buf[pos],188);
                      Tuner.RecvPacket := Tuner.RecvPacket + 1;
                    end;
                    pos := pos + 197;
                    num := num - 197;
                  end;
                  Tuner.BeforeBufSize := num;
                  Move(buf[pos],Tuner.BeforeBuf,num);
                end;

                ret := SI_CheckRXQueue(Tuner.Handle, RxLen, Stat);
                if (ret <> SI_SUCCESS) then RxLen := 0;
              end;
            end
              else
            begin
              // USBG[`[i[؂藣
              SI_Close(Tuner.Handle);
              Tuner.Handle := nil;
              Tuner.TunerState := STATE_NONE;
              Tuner.StatusText := '`[i[~';
            end;
          end;
        end;
     end;
    end;
  except
    //
  end;
end;

// ----------------------------
//   TOTpPbg
// ----------------------------

function TOneSegForm.AnalyzeTOT(buf:PChar; tot:PChar): TDateTime;
var
  ptr,ptr2,i  : Integer;
  table_id    : BYTE;
  sect_len    : WORD;
  mjd         : Integer;
  h,m,s       : Integer;
  ch          : BYTE;
begin
  Result := 0;
  //
  ptr := 5;
  //
  repeat
    table_id := ord(buf[ptr]);
    ptr := ptr + 1;
    if (table_id <> $FF) then
    begin
      sect_len := (ord(buf[ptr])*256 + ord(buf[ptr+1])) and $0FFF;
      ptr  := ptr + 2;
      ptr2 := ptr;

      case table_id of
      $73:
        begin
          // TOT
          mjd := (ord(buf[ptr2])*256 + ord(buf[ptr2+1]));
          ch := ord(buf[ptr2+2]); h := (ch shr 4)*10 + (ch and $F);
          ch := ord(buf[ptr2+3]); m := (ch shr 4)*10 + (ch and $F);
          ch := ord(buf[ptr2+4]); s := (ch shr 4)*10 + (ch and $F);
          Result := ModifiedJulianDateToDateTime(mjd) + EncodeTime(h,m,s,0);   //
          for i:=0 to 4 do tot[i] := buf[ptr2+i];
        end;
      end;
      ptr := ptr + sect_len;
    end;
  until ((ptr>=188) or (table_id = $FF));
end;

procedure TOneSegForm.D1Click(Sender: TObject);
begin
  if Assigned(Tuners) then
  begin
    DaysForm.Channels := Tuners.Count;
    DaysForm.Days := RecDays;
    if (DaysForm.ShowModal = mrOK) then
    begin
      RecDays := DaysForm.Days;
    end;
  end;
end;

procedure TOneSegForm.N1Click(Sender: TObject);
begin
  Application.Restore;
end;

end.
